var Discussions = {
    initialized: false,
    groupdId: null,
    groupUrl: null,
    topicId: null,
    baseParams: null,
    redirectLocation: null,

    initialize: function(groupdId, groupUrl, topicId) {
        if (!Discussions.initialized) {
            Discussions.initialized = true;
            Discussions.groupdId = groupdId;
            if (Discussions.groupdId) {
                Discussions.baseParams = "groupId=" + Discussions.groupdId;
                Discussions.redirectLocation = habboReqPath + "/groups/" + Discussions.groupdId + "/id/discussions";
            }
            Discussions.groupUrl = groupUrl;
            if (Discussions.groupUrl) {
                Discussions.redirectLocation =  habboReqPath + "/groups/" + Discussions.groupUrl + "/discussions";
            }
            Discussions.topicId = topicId;
            if (Discussions.topicId) {
                Discussions.baseParams += "&topicId=" + Discussions.topicId;
            }

            if ($("group-postlist-container")) {
                Event.observe($('group-postlist-container'), 'click', Discussions.handleActions);
            }
            if ($("group-topiclist-container")) {
                Event.observe($('group-topiclist-container'), 'click', Discussions.handleActions);
            }
        }
    },

    handleActions : function(e) {
        var clickedEl = Event.element(e);
        if (clickedEl.className == 'delete-button delete-post') {
            Event.stop(e);
            var entryId = clickedEl.id.substring('delete-post-'.length);
            Discussions.removeEntry(entryId);
        } else if (clickedEl.hasClassName('report-post')) {
            Event.stop(e);
            var entryId = clickedEl.id.substring('report-post-'.length);
            ReportDialogManager.show("discussionpost", entryId, clickedEl, {setWidth: false, setHeight: false, offsetTop: 0,offsetLeft: -120});
        } else if (clickedEl.id == "edit-topic-settings") {
            Event.stop(e);
            Discussions.openTopicSettings();
        } else if (clickedEl.id == "post-form-preview") {
            Event.stop(e);
            Discussions.previewPost();
        } else if (clickedEl.id == "post-form-save" || clickedEl.id == "post-form-save-preview") {
            Event.stop(e);
            Discussions.savePost();
        } else if (clickedEl.id == "post-form-cancel" || clickedEl.id == "post-form-cancel-preview") {
            Event.stop(e);
            Discussions.cancelPost();
        } else if (clickedEl.id == "topic-form-preview") {
            Event.stop(e);
            Discussions.previewTopic();
        } else if (clickedEl.id == "topic-form-save" || clickedEl.id == "topic-form-save-preview") {
            Event.stop(e);
            Discussions.saveTopic();
        } else if (clickedEl.id == "topic-form-cancel" || clickedEl.id == "topic-form-cancel-preview") {
            Event.stop(e);
            Discussions.cancelTopic();
        } else if (clickedEl.className.search('verify-email') > -1 ) {
			Event.stop(e);
			var elementId = clickedEl.id;
			var isEmailVerified = $("email-verfication-ok").value;
			var target = $("postentry-verifyemail-dialog");
        	
        	var verifyEmailExit = function(e) {
            	Event.stopObserving($("postentry-verifyemail-dialog-exit"), "click", verifyEmailExit);
            	Element.hide("postentry-verifyemail-dialog");
            	Overlay.hide();
            };
            
			if (isEmailVerified == 0) {
 				Overlay.show();
        		Dialog.moveDialogToCenter($("postentry-verifyemail-dialog"));
        		Element.show("postentry-verifyemail-dialog");
        		Event.observe($("postentry-verifyemail-dialog-exit"), "click", verifyEmailExit);
        		Event.observe($("postentry-verifyemail-ok"), "click", verifyEmailExit);

       		} else {
       			if ( clickedEl.id.search('quote-post') > -1 ) {
       				var postId = clickedEl.id.substring('quote-post-'.length, clickedEl.id.length-'-message'.length);
					Discussions.quotePost(postId);
       			} else if (clickedEl.id.search('edit-post') > -1) {
       				var postId = clickedEl.id.substring('edit-post-'.length, clickedEl.id.length-'-message'.length);
					Discussions.editPost(postId);
       			} else if (clickedEl.id.search('create-post') > -1 ) {
			        Discussions.createPost();
       			} else if (clickedEl.id == 'newtopic-upper' || clickedEl.id == 'newtopic-lower') {
       		        Discussions.createTopic();
       			}
       		}
        }
    },

    showEditElements : function() {
        if ($("new-topic-entry-label")) {
            Element.show("new-topic-entry-label");
        }
        Element.show("new-post-entry-message");
        $("post-message").focus();
        Element.scrollTo('post-message');
    },

    hideEditElements : function() {
        if ($("new-topic-entry-label")) {
            Element.hide("new-topic-entry-label");
        }
        Element.hide("new-post-entry-message");
    },

    removeEntry : function (id) {
        offsets = Position.cumulativeOffset($("delete-post-" + id));
        var target = $("postentry-delete-dialog");
        Position.absolutize(target);
        var containerScrollTop = $('group-postlist-list').scrollTop;
        target.style.top    = (offsets[1] - containerScrollTop) + 'px';
        target.style.left   = (offsets[0]-250) + 'px';
        var postentryDeleteCancel = function(e) {
            Event.stopObserving($("postentry-delete-cancel"), "click", postentryDeleteCancel);
            Element.hide("postentry-delete-dialog");
        };
        Event.observe($("postentry-delete-cancel"), "click", postentryDeleteCancel);
        var postentryDeleteExit = function(e) {
            Event.stopObserving($("postentry-delete-dialog-exit"), "click", postentryDeleteExit);
            Element.hide("postentry-delete-dialog");
        };
        Event.observe($("postentry-delete-dialog-exit"), "click", postentryDeleteExit);
        var postentryDelete = function(e) {
            Event.stopObserving($("postentry-delete"), "click", postentryDelete);
            Discussions.deletePost(id);
            Element.hide("postentry-delete-dialog"); 
        };
        Event.observe($("postentry-delete"), "click", postentryDelete);
        Element.show("postentry-delete-dialog");
    }, 

	editPost : function(postId) {
		Discussions.showEditElements();
		var editText = $(postId+'-message');
		var messageText = $('post-message');
		$('edit-type').value = "update";
		$('post-id').value = postId;
		messageText.value = editText.value;
	},

	quotePost : function(postId) {
        Discussions.showEditElements();
        var quoteText = $(postId+'-message');
		var messageText = $('post-message');
		messageText.value = '[quote]' + quoteText.value + '[/quote]';
		$('edit-type').value = "new";
	},

	cancelPost : function() {
        Discussions.hideEditElements();
        if ($("create-post-message")) { Element.show("create-post-message"); }
	    if ($("create-post-message-lower")) { Element.show("create-post-message-lower"); }
        if ($("new-post-preview")) {
            Element.hide("new-post-preview");
        }
	},

	cancelTopic : function() {
		location.href = Discussions.redirectLocation;
	}, 

    createPost : function() {
        var params = Discussions.baseParams;

        $('post-message').value = "";
        $('post-id').value = null;
        Discussions.showEditElements();
        if ($("create-post-message")) { Element.hide("create-post-message"); }
        if ($("create-post-message-lower")) { Element.hide("create-post-message-lower"); }
    },

	createTopic : function() {
        var params = Discussions.baseParams;

        new Ajax.Updater('group-topiclist-container', '/discussions/actions/newtopic', { method:"post", evalScripts:true, parameters:params,
			onComplete:function(req, json) {
	            if (json && json.forbidden == "true") {
	                $('discussionbox').innerHTML = req.responseText;
	                return;
	            }
                Discussions.showEditElements();
                $("new-topic-name").focus();
			}
		});
	}, 

	previewPost : function() {
        Discussions.preview(null);
    },

    previewTopic : function() {
		var topicName = encodeURIComponent($('new-topic-name').value);
        Discussions.preview(topicName);
    },

    preview : function(topicName) {
        var messageText = encodeURIComponent($('post-message').value);
        var params = Discussions.baseParams + "&message=" + messageText;
        var type = "post";
        if (topicName != null) {
            type = "topic";
            params += "&topicName=" + topicName;
        }

        new Ajax.Updater("new-" + type + "-preview", habboReqPath + "/discussions/actions/preview" + type, { method:"post", parameters:params,
            onComplete:function(req, json) {

                Discussions.hideEditElements();
                Element.show("new-" + type + "-preview");

                if (json && json.forbidden == "true") {
                    return;
                }

                Event.observe("edit-post-message", "click", function(e) {
                    Event.stop(e);
                    Element.hide("new-" + type + "-preview");
                    Discussions.showEditElements();
                }, false);
            }
        });
    },

    savePost : function() {
        Element.hide("post-form-save");
        Discussions.save(null);
    },

    saveTopic : function() {
        var topicName = encodeURIComponent($('new-topic-name').value.replace(/^\s+|\s+$/, ''));
        if (topicName.length == 0) {
            Discussions.showTopicNameErrorBubble("topic-name-error");
            return;
        }
        Element.hide("topic-form-save");
        Discussions.save(topicName);
    },

    save : function(topicName) {
        var messageText = encodeURIComponent($('post-message').value);
        var params = Discussions.baseParams + "&message=" + messageText;
        var type = "post";
        var reqPath;
        if (topicName != null) {
            type = "topic";
            params += "&topicName=" + topicName;
            reqPath = habboReqPath + "/discussions/actions/savetopic";
        } else {
            var editType = $('edit-type').value;
            var currentPage = $('current-page').value;
            if (editType == "update") {
                reqPath = habboReqPath + '/discussions/actions/updatepost';
                params += "&postId=" + $('post-id').value;
            } else {
                reqPath = habboReqPath + '/discussions/actions/savepost';
                currentPage = -1;
            }
            params += "&page=" + currentPage;
        }

        new Ajax.Request(reqPath, { method:"post", parameters:params,
                onComplete:function(req, json) {
                    var spamMessage = $('spam-message').value;
                    if (json && json.spam == "true") {
                        req.responseText.evalScripts();
                        Element.hide("new-" + type + "-preview");
                        Discussions.showEditElements();
                    } else if (json && json.forbidden == "true") {
                        $('discussionbox').innerHTML = req.responseText;
                        return;
                    } else if (type == "post") {
                        $('group-postlist-container').innerHTML = req.responseText;
                        req.responseText.evalScripts();
                    } else if (type == "topic") {
                        var redirectLocation = req.responseText;
                        if (redirectLocation != null && redirectLocation.startsWith("/groups")) {
                            document.location = redirectLocation;
                        } else {
                            $('group-topiclist-container').innerHTML = req.responseText;    
                        }
                    }
                }
        });
    },

    deletePost : function(postId) {
        var params = Discussions.baseParams + "&postId=" + postId;
        var currentPage = $('current-page').value;
        params += "&page=" + currentPage;

        new Ajax.Request(habboReqPath + '/discussions/actions/deletepost', { method:"post", parameters:params,
	        onComplete:function(req, json) {
	            if (json && json.forbidden == "true") {
	                $('discussionbox').innerHTML = req.responseText;
                    req.responseText.evalScripts();
                    return;
	            } else if (req.responseText == 'TOPIC_DELETED') {
                    document.location = Discussions.redirectLocation;
                    return;
                }
                $('group-postlist-container').innerHTML = req.responseText;
            }
	    });
	}, 
	
    deleteTopic : function(e) {
        Event.stop(e);
        var params = Discussions.baseParams;

        new Ajax.Request(habboReqPath + '/discussions/actions/deletetopic', { method:"post", parameters:params,
            onComplete:function(req, json) {
                if (json && json.forbidden == "true") {
                    $('discussionbox').innerHTML = req.responseText;
                    return;
                }
                if (req.responseText == 'SUCCESS') {
                    document.location = Discussions.redirectLocation;
                }
            }
        });
    },

	openTopicSettings : function() {
		var params = Discussions.baseParams;
	
        var dialogTitle = $('settings_dialog_header').value;
	    var dialog = Dialog.createDialog("topic_settings_dialog", dialogTitle, 9001, 0, -1000, Discussions.closeTopicSettings);
	    Dialog.appendDialogBody(dialog, "<p style=\"text-align:center\"><img src=\"" + habboStaticFilePath + "/images/progress_bubbles.gif\" alt=\"\" width=\"29\" height=\"6\" /></p><div style=\"clear\"></div>", true);
	    Dialog.moveDialogToCenter(dialog);
	    Overlay.show();
		new Ajax.Request(habboReqPath + "/discussions/actions/opentopicsettings", { method: "post", parameters:params,
            onComplete: function(req, json) {
				Dialog.setDialogBody(dialog, req.responseText);
	            $("topic_settings_dialog").style.width="305px";
	            if (json && json.forbidden == "true") {
	                Event.observe("general-info-dialog-button", "click", Discussions.closeTopicSettings, false);
	                return;
	            }
	            Event.observe("save-topic-settings", "click", Discussions.saveTopicSettings, false);
	            Event.observe("cancel-topic-settings", "click", Discussions.closeTopicSettings, false);
	            Event.observe("delete-topic", "click", Discussions.deleteTopicConfirmation, false);
			} }
		);
	}, 
	
    closeTopicSettings : function(e) {
        Event.stop(e);
        Element.remove("topic_settings_dialog");
        Overlay.hide();
    },

	deleteTopicConfirmation : function(e) {
        Event.stop(e);
	    Discussions.closeTopicSettings(e);
	    var dialogTitle = $('settings_dialog_header').value;
	    var dialog = Dialog.createDialog("delete-topic-confirmation", dialogTitle, 9001, 0, -1000);
	    Dialog.moveDialogToCenter(dialog);
	    Overlay.show();
	    Dialog.setAsWaitDialog(dialog);
	
		new Ajax.Request(habboReqPath + "/discussions/actions/confirm_delete_topic", { method:"post",
			onComplete:function(req, json) {
	            Dialog.setDialogBody(dialog, req.responseText);
				Event.observe($("discussion-action-cancel"), "click", function(e) { Event.stop(e); Element.remove("delete-topic-confirmation"); Overlay.hide();});
	            Event.observe($("discussion-action-ok"), "click", function(e) { Event.stop(e); Element.remove("delete-topic-confirmation"); Overlay.hide(); Discussions.deleteTopic(e);});
			}
		});
	}, 
	
	saveTopicSettings : function(e) {
		Event.stop(e);
        var topicName = $('topic_name').value.replace(/^\s+|\s+$/, '');
        if (topicName.length == 0) {
            Discussions.showTopicNameErrorBubble("topic-name-error");
            return;
        }
		var topicClosed = 0;
		var topicSticky = 0;
		var form = $('topic-settings-form');
		var type_group = form.topic_type;
		for (var i = 0; i < type_group.length; i++) {
			if (type_group[i].checked) {
				topicClosed = type_group[i].value; 
			}
		}
		var sticky_group = form.topic_sticky;
		for (var i = 0; i < sticky_group.length; i++) {
			if (sticky_group[i].checked) {
				topicSticky = sticky_group[i].value; 
			}
		}
		var params = Discussions.baseParams + "&topicName=" + encodeURIComponent(topicName) + "&topicClosed=" + topicClosed + "&topicSticky=" + topicSticky;
        var currentPage = $('current-page').value;
        params += "&page=" + currentPage;
        Discussions.closeTopicSettings(e);

		new Ajax.Updater('group-postlist-container', habboReqPath + '/discussions/actions/savetopicsettings', { method:"post", parameters:params,
			onComplete:function(req, json) {
	            if (json && json.forbidden == "true") {
	                return;
	            }
                req.responseText.evalScripts();
            }
		});
	},

    showTopicNameErrorBubble : function(containerElementId) {
        if (!$(containerElementId).hasChildNodes()) {
            var errorElement = Builder.node("div", { className: "rounded-red" }, L10N.get("myhabbo.discussion.error.topic_name_empty"));
            $(containerElementId).appendChild(errorElement);
            Rounder.addCorners(errorElement, 8, 8);
        }
    }

};
